Program Floyd (input,output);
Uses
  Crt;
const
     direc_nula='';

Type
   m_adya=array ['R'..'U','R'..'U'] of longint;
   m_trayec=array ['R'..'U','R'..'U'] of string;
Var
   grafo:m_adya;
   trayec:m_trayec;

Procedure asignar (var grafo:m_adya);
Var
   i,j:char;
   test:boolean;

   Procedure inicializar (var grafo:m_adya);
   Var
      i,j:char;
   Begin
      for i:='R' to 'U' do
         for j:='R' to 'U' do
            grafo [i,j]:=MAXINT
   End;

Begin
   test:=false;
   inicializar(grafo);
   Repeat
      clrscr;
      write ('Origen: ');
      i:=upcase(readkey);
      writeln (i);
      write ('Destino: ');
      j:=upcase(readkey);
      writeln (j);
      if (i in ['R'..'U']) and (j in ['R'..'U']) then
         Begin
            write ('Peso: ');
            readln (grafo [i,j])
         End
      Else
         test:=true
   Until test
End;

Procedure proceso (var grafo:m_adya;var trayec:m_trayec);
Var
   i,j,k:char;
   test:boolean;
   aux:m_adya;
   taux:m_trayec;

   Function minimo (a,b:longint;var test:boolean):longint;
   Var
      aux:longint;
   Begin
        test:=false;
        if (a>=MAXINT) and (b>=MAXINT)
        then
             aux:=MAXINT
        else
            if (a<=b)
               then
                    aux:=a
               Else
                   Begin
                        test:=true;
                        aux:=b
                   End;

         minimo:=aux
   End;

Begin

   { Definicin de las trayectorias nodales }

   for i:='R' to 'U' do
       for j:='R' to 'U' do
          if grafo[i,j]=MAXINT
             then trayec[i,j]:=direc_nula
             else trayec[i,j]:=i+j;

   for k:='R' to 'U' do
      Begin
         aux:=grafo;
         taux:=trayec;
         for i:='R' to 'U' do
             for j:='R' to 'U' do
                 Begin
                      grafo [i,j]:=minimo (aux [i,j],aux [i,k]+aux [k,j],test);
                      if test
                         then
                            trayec [i,j]:=taux[i,k]+taux[k,j];
                 End
      End
End;

Procedure visualizar_grafo (grafo:m_adya);
Var
   i,j:char;
Begin
     for i:='R' to 'U' do
         begin
              for j:='R' to 'U' do
                  write (grafo [i,j]:3);
              writeln
         end
End;

Procedure visualizar_matriz (trayec:m_trayec);
Var
   i,j:char;
   cadena1,cadena2:string;
procedure quitar_duples(cadena1:string;var cadena2:string);
var
   i:integer;
begin
     if length (cadena1)<=2
        then cadena2:=cadena1
        else
            begin
                 cadena2:=cadena1[1];
                 for i:=1 to length(cadena1) do
                       begin
                            if cadena2[length(cadena2)]<>cadena1[i]
                               then cadena2:=cadena2+cadena1[i]
                       end
           end
end;
Begin
     for i:='R' to 'U' do
         begin
              for j:='R' to 'U' do
                  begin
                       cadena1:=trayec[i,j];
                       quitar_duples(cadena1,trayec[i,j]);
                       write (trayec[i,j]:10)
                  end;
              writeln
         end
End;

Begin {del programa principal}
   asignar (grafo);
   proceso (grafo,trayec);
   visualizar_grafo (grafo);
   visualizar_matriz (trayec)
End.

