Program warshall (input,output);
Uses
  Crt;

Type
   m_adya=array ['A'..'D','A'..'D'] of boolean;
Var
   grafo:m_adya;

Procedure asignar (var grafo:m_adya);
Var
   i,j:char;
   test:boolean;

   Procedure inicializar (var grafo:m_adya);
   Var
      i,j:char;
   Begin
      for i:='A' to 'D' do
         for j:='A' to 'D' do
            grafo [i,j]:=false
   End;

Begin
   clrscr;
   inicializar(grafo);
   test:=false;
   Repeat
      write ('Origen: ');
      i:=upcase(readkey);
      writeln (i);
      write ('Destino: ');
      j:=upcase(readkey);
      writeln(j);
      if (i in ['A'..'D']) and (j in ['A'..'D'])
         then
            grafo [i,j]:=true
         Else
             test:=true
   Until test
End;

Procedure proceso (var grafo:m_adya);
Var
   i,j,k:char;
   aux:m_adya;

Begin
   for k:='A' to 'D' do
      Begin
         aux:=grafo;
         for i:='A' to 'D' do
             for j:='A' to 'D' do
                 grafo [i,j]:=aux [i,j] or (aux [i,k] and aux[k,j]);
      End
End;

Procedure visualizar_grafo (grafo:m_adya);
Var
   j,i:char;
Begin
   for i:= 'A' to 'D' do
       begin
            for j:='A' to 'D' do
                if grafo[i,j] then write (1:3)
                              else write (0:3);

            writeln
       end
End;

Begin {del programa principal}
   asignar (grafo);
   proceso (grafo);
   visualizar_grafo (grafo);
End.
