program equilibrar (input,output);
uses crt;
type
    ref=^nodo;
    nodo=record
               palabra:string;
               clave,contador,equi:integer;
               izquierdo,derecho:ref
         end;
var
   p:ref;
   h:boolean;

procedure asignar (x:integer;var p:ref;var h:boolean);
var
   p1,p2:ref;
begin
     if p=nil
        then
            begin
                 new (p);
                 h:=true;
                 with p^ do
                      begin
                           clave:=x;
                           contador:=1;
                           izquierdo:=nil;
                           derecho:=nil;
                           equi:=0
                      end
            end
        else
            if x < p^.clave
               then
                   begin
                        asignar(x,p^.izquierdo,h);
                        if h
                           then
                               case p^.equi of
                                    1: begin
                                            p^.equi:=0;
                                            h:=false
                                       end;
                                    0: p^.equi:= -1;
                                   -1: begin
                                            p1:=p^.izquierdo;
                                            if p1^.equi=-1
                                               then
                                                   begin (* rotacin II simple *)
                                                        p^.izquierdo:=p1^.derecho;
                                                        p1^.derecho:=p;
                                                        p^.equi:=0;
                                                        p:=p1
                                                   end
                                               else
                                                   begin (* rotacin ID doble *)
                                                         p2:=p1^.derecho;
                                                         p1^.derecho:=p2^.izquierdo;
                                                         p2^.izquierdo:=p1;
                                                         p^.izquierdo:=p2^.derecho;
                                                         p2^.derecho:=p;
                                                         if p2^.equi=-1 then p^.equi:=1
                                                                        else p^.equi:=0;
                                                         if p2^.equi=1 then p1^.equi:=-1
                                                                        else p1^.equi:=0;
                                                         p:=p2;
                                                   end;
                                               p^.equi:=0;
                                               h:=false
                                       end
                               end
                   end
               else
                   if x > p^.clave
                      then
                          begin
                               asignar (x,p^.derecho,h);
                               if h
                                  then
                                      case p^.equi of
                                           -1: begin
                                                   p^.equi:=0;
                                                   h:=false
                                               end;
                                           0: p^.equi:= 1;
                                           1: begin
                                                   p1:=p^.derecho;
                                                   if p1^.equi=1
                                                      then
                                                          begin (* rotacin DD simple *)
                                                                p^.derecho:=p1^.izquierdo;
                                                                p1^.izquierdo:=p;
                                                                p^.equi:=0;
                                                                p:=p1
                                                          end
                                                      else
                                                          begin (* rotacin DI doble *)
                                                                p2:=p1^.izquierdo;
                                                                p1^.izquierdo:=p2^.derecho;
                                                                p2^.derecho:=p1;
                                                                p^.derecho:=p2^.izquierdo;
                                                                p2^.izquierdo:=p;
                                                                if p2^.equi=1 then p^.equi:=-1
                                                                        else p^.equi:=0;
                                                                if p2^.equi=-1 then p1^.equi:=1
                                                                        else p1^.equi:=0;
                                                                p:=p2;
                                                          end;
                                                  p^.equi:=0;
                                                  h:=false
                                              end

                          end
        end
     else
         begin
              p^.contador:=p^.contador+1;
              h:=false
         end
end;

procedure visualizar (a:ref; h:integer);
	  var
	     i:integer;

begin { imprimir arbol a con margen h }
      if a<> nil then
	     with a^ do
		  begin
		       visualizar (izquierdo, h+1);
		       for i:=1 to h do write ('     ');
		       writeln (clave,'(',equi,')');
		       visualizar (derecho, h+1)
		  end

end { imprimir arbol };

begin
     h:=false;
     p:=nil;
     clrscr;
     asignar (4,p,h);
     asignar (5,p,h);
     asignar (7,p,h);
     asignar (2,p,h);
     asignar (1,p,h);
     asignar (3,p,h);
     clrscr;
     visualizar(p,0);
     asignar (6,p,h);
     writeln;
     writeln;
     visualizar(p,0);

end.







