program arboles (input,output);
uses crt;
type
    informacion=char;
    puntero=^nodo;
       nodo=record
                  dato:informacion;
                  izquierdo,derecho:puntero
            end;
var
   raiz:puntero;

{ 1 --------------------------------------------------------------------------}

procedure creararbol ( var raiz:puntero);
var
   c:char;
{ 2 --------------------------------------------------------------------------}
                {se inserta como en las listas enlazadas}
procedure insertar (var raiz:puntero;elemento:informacion);
var
   nuevonodo,p,anterior:puntero;
begin
     new (nuevonodo);
     nuevonodo^.izquierdo:=NIL;
     nuevonodo^.derecho:=NIL;
     nuevonodo^.dato:=elemento;
     p:=raiz;
     anterior:=NIL;
     while p<>NIL do    {Buscar el lugar donde va ha ser insertado}
           begin
                anterior:=p;
                if p^.dato > elemento
                           then p:=p^.izquierdo
                           else p:=p^.derecho
           end;
    if anterior=NIL  {es el primer nodo}
       then raiz:=nuevonodo
       else
           if anterior^.dato > elemento
              then anterior^.izquierdo:=nuevonodo
              else anterior^.derecho:=nuevonodo
end;
{ 2 --------------------------------------------------------------------------}
function termino:boolean;
var
   c:char;
begin
     writeln;
     writeln;
     write ('PARA TERMINAR=> ESC: ');
     c:=readkey;
     termino:=(c=chr(27))
end;

{ 1 --------------------------------------------------------------------------}
begin
     clrscr;
     raiz:=NIL;
     repeat
           clrscr;
           write ('Caracter: ');
           readln (c);
           insertar (raiz,c)
      until termino

end;
{ 1 --------------------------------------------------------------------------}
procedure visualizar (raiz:puntero);
type
    tipopila=record
                   elementos:array[1..100] of puntero;
                   cab:0..100
             end;
var
   pila:tipopila;
   p:puntero;
{ 2 --------------------------------------------------------------------------}
procedure limpiarpila (var pila:tipopila);
begin
     pila.cab:=0
end;

{ 2 --------------------------------------------------------------------------}
procedure meter (var pila:tipopila;p:puntero);
begin
     pila.cab:=succ (pila.cab);
     pila.elementos [pila.cab]:=p
end;
{ 2 --------------------------------------------------------------------------}
procedure sacar (var pila:tipopila; var p:puntero);
var
   ptr:tipopila;
begin
     p:=pila.elementos[pila.cab];
     pila.cab:=pred (pila.cab)
end;
{ 2 --------------------------------------------------------------------------}
function pilavacia (pila:tipopila):boolean;
begin
     pilavacia:=(pila.cab=0 )
end;

{ 1 --------------------------------------------------------------------------}
begin
     limpiarpila (pila);
     p:=raiz;
     repeat
           while p<>nil do
                 begin
                      meter (pila,p);
                      p:=p^.izquierdo
                 end;
           if not pilavacia (pila)
              then
                  begin
                       sacar (pila,p);
                       write (p^.dato:10);
                       p:=p^.derecho
                  end
     until (p=nil) and (pilavacia (pila))
end;

{ 1 --------------------------------------------------------------------------}
{ 0 --------------------------------------------------------------------------}
begin
     creararbol (raiz);
     visualizar (raiz)
end.
{ 0 --------------------------------------------------------------------------}





