UNIT UNIARBOL;
INTERFACE

uses dos,crt;

type
    informacion=integer;
    puntero=^nodo;
    nodo = record
               dato:informacion;
               izquierdo,derecho:puntero
         end;
procedure inicializar (var raiz:puntero);
procedure insertar (var raiz:puntero;elemento:informacion);
procedure PostOrden1 (raiz:puntero);
procedure PostOrden2 (raiz:puntero);
procedure PreOrden1 (raiz:puntero);
procedure PreOrden2 (raiz:puntero);
procedure InOrden1 (raiz:puntero);
procedure InOrden2 (raiz:puntero);
procedure Suprimir1 (var raiz:puntero;clave:informacion);
procedure Suprimir2 (var p:puntero;x:informacion);

IMPLEMENTATION

type
    tipopila = record
                   elementos:array[1..100] of puntero;
                   cab:0..100
             end;

procedure limpiarpila (var pila:tipopila);
begin
     pila.cab:=0
end;

procedure meter (var pila:tipopila;p:puntero);
begin
     pila.cab:=succ (pila.cab);
     pila.elementos [pila.cab]:=p
end;

procedure sacar (var pila:tipopila; var p:puntero);
begin
     p:=pila.elementos[pila.cab];
     pila.cab:=pred (pila.cab)
end;

function pilavacia (pila:tipopila):boolean;
begin
     pilavacia:=(pila.cab=0 )
end;


procedure inicializar (var raiz:puntero);
begin
     raiz:=nil
end;

procedure insertar (var raiz:puntero;elemento:informacion);
var
   nuevonodo,p,anterior:puntero;
begin
     new (nuevonodo);
     nuevonodo^.izquierdo:=NIL;
     nuevonodo^.derecho:=NIL;
     nuevonodo^.dato:=elemento;
     p:=raiz;
     anterior:=NIL;
     while p<>NIL do
	   begin
                anterior:=p;
                if p^.dato > elemento
                           then p:=p^.izquierdo
                           else p:=p^.derecho
           end;
    if anterior=NIL
       then raiz:=nuevonodo
       ELSE
           if anterior^.dato > elemento
              then anterior^.izquierdo:=nuevonodo
              else anterior^.derecho:=nuevonodo
end;

procedure PostOrden2 (raiz:puntero);

var
   pila:tipopila;
   p:puntero;

begin
     limpiarpila (pila);
     p:=raiz;
     repeat
           while p<>nil do
		 begin
                      meter (pila,p);
                      if p^.derecho<>NIL
                         then meter (pila,NIL);
                      p:=p^.izquierdo;
                 end;
           if not pilavacia (pila)
                   then
		       begin
                            sacar(pila,p);
			    IF p = nil THEN
					 begin
                                              sacar (pila,p);
                                              meter (pila,p);
                                              p:=p^.derecho
					 END
				     ELSE
					 begin
                                              write (p^.dato:10);
                                              p:=nil
					 END

                       end;

     until (p=nil) and (pilavacia (pila))
end;
procedure PostOrden1 (raiz:puntero);
begin
     if raiz<>nil
        then
	    begin
                 postorden1 (raiz^.izquierdo);
                 postorden1 (raiz^.derecho);
                 write (raiz^.dato:10)
	    END
end;
procedure PreOrden1 (raiz:puntero);
begin
     if raiz<>nil
        then
	    begin
                 write (raiz^.dato:10);
                 PreOrden1 (raiz^.izquierdo);
                 PreOrden1 (raiz^.derecho)
	    END
end;
procedure InOrden1 (raiz:puntero);
begin
     if raiz<>nil
        then
	    begin
                 InOrden1 (raiz^.izquierdo);
                 write (raiz^.dato:10);
                 InOrden1 (raiz^.derecho)
	    END
end;

procedure escribe(co1,co2:byte; cara:informacion);
begin;
gotoxy(co1,co2);
write(cara);
end;

function mitad(co1,co2:byte):byte;
begin;
   mitad:=co1+((co2-co1) div 2);
end;

procedure calcula (var cox,coy,ancho,posiz,posde:byte;raiz:puntero);
begin;
if raiz<>nil then
begin
     escribe (cox,coy,raiz^.dato);
     calcula (mitad(posiz,posde),coy,ancho,posiz,posde,raiz^.izquierdo);
     calcula (mitad(posiz,posde)+posde,coy,ancho,posiz,posde,raiz^.derecho);
     coy:=coy+2;
end
end;

procedure PreOrden2 (raiz:puntero);
var
   pila:tipopila;
   p:puntero;

begin
     limpiarpila (pila);
     p:=raiz;
     repeat
           while p<>nil do
		 begin
                      write (p^.dato:10);
                      meter (pila,p);
                      p:=p^.izquierdo
                 end;
           if not pilavacia (pila)
              then
		  begin
                       sacar (pila,p);
                       p:=p^.derecho
		  END
     until (p=nil) and (pilavacia (pila))
end;

procedure InOrden2 (raiz:puntero);
var
   pila:tipopila;
   p:puntero;
begin
     limpiarpila (pila);
     p:=raiz;
     repeat
           while p<>nil do
		 begin
                      meter (pila,p);
                      p:=p^.izquierdo
                 end;
           if not pilavacia (pila)
              then
		  begin
                       sacar (pila,p);
                       write (p^.dato:10);
                       p:=p^.derecho
		  END
     until (p=nil) and (pilavacia (pila))
end;

procedure Pinta (raiz:puntero);
var
   pila:tipopila;
   p,actual:puntero;
   cordx,cordy,altura,anch:byte;

begin
     clrscr;
      p:=raiz;
     altura:=1;
     cordy:=1;
     anch:=40;
     cordx:=mitad(1,80);
     calcula(cordx,cordy,anch,p);
end;



procedure Suprimir1 (var raiz:puntero;clave:informacion);
var
   ptr,ant:puntero;
   encontrado:boolean;

procedure SuprimirNodo (var p:puntero;ptr,ant:puntero);
var
   temp:puntero;
begin
     if (ptr^.derecho=nil) and (ptr^.izquierdo=nil)
        then
            if ant=nil
               then p:=nil
	       ELSE
                   if ant^.derecho=ptr
                      then ant^.derecho:=nil
                      else ant^.izquierdo:=nil
	ELSE
            if (ptr^.derecho<>nil) and (ptr^.izquierdo<>nil)
               then
		   begin
                        ant:=ptr;
                        temp:=ptr^.izquierdo;
                        while (temp^.derecho<>nil) do
			      begin
                                   ant:=temp;
                                   temp:=temp^.derecho
                              end;
                        ptr^.dato:=temp^.dato;
                        if ant=ptr
                           then ant^.izquierdo:=temp^.izquierdo
                           else ant^.derecho:=temp^.izquierdo;
                        ptr:=temp
		   END
	       ELSE
                   if (ptr^.derecho<>nil)
                      then if ant=nil
                           then p:=ptr^.derecho
			   ELSE
                               if ant^.derecho=ptr
                                  then ant^.derecho:=ptr^.derecho
                                  else ant^.izquierdo:=ptr^.derecho
                      else if ant=nil
                           then p:=ptr^.izquierdo
			   ELSE
                               if ant^.derecho=ptr
                                  then ant^.derecho:=ptr^.izquierdo
                                  else ant^.izquierdo:=ptr^.izquierdo;

     dispose(ptr);
end;

begin
     ptr:=raiz;
     ant:=nil;
     encontrado:=false;
     while (ptr<>nil) and not encontrado do
           if ptr^.dato=clave
              then encontrado:=true
	      ELSE
		  begin
                       ant:=ptr;
                       if ptr^.dato>clave
                          then ptr:=ptr^.izquierdo
                          else ptr:=ptr^.derecho
                  end;
     if encontrado
        then SuprimirNodo(raiz,ptr,ant)
end;

procedure Suprimir2 (var p:puntero;x:informacion);
var
   q:puntero;
procedure bor (var d:puntero);
begin
     if (d^.derecho<>nil)
        then bor(d^.derecho)
	ELSE
	    begin
                 q^.dato:=d^.dato;
                 q:=d;
                 d:=d^.izquierdo
	    END
end;
begin
     if (p<>nil)
        then
            if (x<p^.dato) then Suprimir2 (p^.izquierdo,x)
                           else if (x>p^.dato)
                                   then Suprimir2 (p^.derecho,x)
				   ELSE
				       begin
                                            q:=p;
                                            if q^.derecho=nil then p:=q^.izquierdo
                                                              else if q^.izquierdo=nil
                                                                   then p:=q^.derecho
                                                                   else bor(q^.izquierdo)
				       END
end;
begin
end.

